<template>
  <div class="py-md-3">
    <slot />
    <b-row>
      <b-col md="12" class="d-flex flex-row">
        <v-lazy-image
          :src-placeholder="book.dedication.image | image | imageSize('small')"
          :src="book.dedication.image | image"
          :alt="book.title"
          class="dedication-cover d-none d-md-block mr-4"
        />
        <form class="d-flex flex-column h-100" style="flex: 1;" @submit.prevent="onSubmit()">
          <b-form-textarea
            v-model="dedication"
            :maxlength="maxDedicationLength"
            class="dedication text-dark"
          />
          <div class="clearfix">
            <div class="float-left">
              <span class="text-secondary">
                {{ dedicationLeft }}
              </span>
            </div>
            <div class="float-right">
              <b-button v-if="isIdenticalData" variant="danger" class="btn--right w-100" type="submit">
                {{ $t('close') }}
              </b-button>
              <b-button v-else variant="success" class="btn--right w-100" type="submit">
                {{ $t('edit') }}
              </b-button>
            </div>
          </div>
        </form>
      </b-col>
    </b-row>
  </div>
</template>

<script>
export default {
  name: 'NamebookDedication',
  props: {
    name: {
      type: String,
      required: true
    },
    book: {
      type: Object,
      required: true
    },
    dedicationText: {
      type: String,
      default: ''
    }
  },
  data () {
    return {
      dedication: '',
      maxDedicationLength: 400
    }
  },
  computed: {
    dedicationLength () {
      return this.maxDedicationLength - this.dedication.length
    },
    dedicationLeft () {
      return this.$t('namebook.dedication_left.' + this.$options.filters.declareNum([0, 1, 2], this.dedicationLength),
        { count: this.dedicationLength })
    },
    isIdenticalData () {
      return this.dedication === this.dedicationText
    }
  },
  mounted () {
    if (this.dedication === '') {
      this.dedication = this.dedicationText
    }
  },
  methods: {
    onSubmit () {
      if (!this.isIdenticalData) {
        this.$emit('setDedication', this.dedication)
      }
      this.$emit('hide')
    }
  }
}
</script>

<style lang="scss" scoped>
    //noinspection CssUnknownTarget
    @import "@/assets/scss/_variables.scss";
    @import "~bootstrap/scss/mixins/breakpoints";
    .dedication {
        margin-bottom: 1rem;
        flex: 1;
        min-height: 4rem;
        @include media-breakpoint-down(sm) {
          min-height: 15rem;
        }
    }
    .dedication-cover {
      height: 22rem;
      min-width: 25rem;
      object-fit: cover;
    }
</style>
